#include <amxmodx>
#include <amxmisc>
#include <sqlx>

//#define COLORED_TRANSLIT // раскомментировать, если на сервере стоит Colored Translit 3.0

#define PLUGIN "Web Chat"
#define VERSION "1.3.1"
#define AUTHOR "BaHeK"

new Handle:g_h_Sql, Handle:g_h_Sql_Connect
new g_pCvarSQLHost
new g_pCvarSQLUser
new g_pCvarSQLPass
new g_pCvarSQLDb
new g_pCvar_ipfix
new g_pCvar_sim
new g_pCvar_reconnectmysql
new g_pCvar_reconnecttime
#if !defined COLORED_TRANSLIT
new g_pCvar_rusfix, g_pCvar_allchat, g_pCvar_adminlisten, rusfix, allchat, adminlisten
new maxplayers
#endif
new ignore, rcmysql
new bool:is_connected_mysql
new host[64], user[64], pass[128], db[128], _hostip[32], message[192]
new Float:reconnecttime

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	g_pCvarSQLHost = register_cvar( "amx_webchat_host", "localhost" )
	g_pCvarSQLUser = register_cvar( "amx_webchat_user", "root" )
	g_pCvarSQLPass = register_cvar( "amx_webchat_pass", "" )
	g_pCvarSQLDb = register_cvar( "amx_webchat_db", "" )
	g_pCvar_ipfix = register_cvar( "amx_webchat_ipfix", "" )
	g_pCvar_sim = register_cvar( "amx_webchat_ignore_sim", "0" )
	g_pCvar_reconnectmysql = register_cvar( "amx_webchat_reconnectmysql", "1" )
	g_pCvar_reconnecttime = register_cvar( "amx_webchat_reconnecttime", "20" )
#if !defined COLORED_TRANSLIT
	g_pCvar_rusfix = register_cvar( "amx_webchat_rusfix", "0" )
	g_pCvar_allchat = register_cvar( "amx_webchat_allchat", "0" )
	g_pCvar_adminlisten = register_cvar( "amx_webchat_listen", "1" )
	register_clcmd("say", "websay")
	register_clcmd("say_team", "websay_team")
	maxplayers = get_maxplayers()
#endif
	set_task(0.3, "connect_data_base")
}
#if defined COLORED_TRANSLIT
forward ct_message_translit(id, msg[], isteam)

public ct_message_translit(id, msg[], isteam)
{
	to_log(id, isteam, msg)
}

public to_log(id, teamchat, mes[])
#else
public websay(id)
	return to_log(id, 0)

public websay_team(id)
	return to_log(id, 1)

public to_log(id, teamchat)
#endif
{
	if(!is_user_connected(id)||is_user_bot(id)||is_user_hltv(id)) return PLUGIN_HANDLED
	if(is_connected_mysql)
	{
		new name[33], steam[33], ip[33], hostip[32], team, alive, zapr[1024], msg[400], _hostip1[64], _name[66]
		get_user_name(id, name, 32)
		get_user_ip(id, ip, 32, 1)
		get_user_authid(id, steam, 32)
		get_pcvar_string(g_pCvar_ipfix, _hostip, 31)
		if(equali(_hostip, ""))
			get_user_ip(0, hostip, 31)
		else
			formatex(hostip, 31, "%s", _hostip)
#if !defined COLORED_TRANSLIT
		read_args(message, 191)
#else
		formatex(message, 191, "%s", mes)
#endif
		remove_quotes(message)
		if(message[0]=='@'&&teamchat==1) return PLUGIN_HANDLED_MAIN
		if(ignore&&message[0]=='/') return PLUGIN_HANDLED_MAIN
		SQL_QuoteString(g_h_Sql_Connect, msg, 399, message)
		SQL_QuoteString(g_h_Sql_Connect, _hostip1, 63, hostip)
		SQL_QuoteString(g_h_Sql_Connect, _name, 65, name)
		if(!message[0])
			return PLUGIN_HANDLED
		if(is_user_alive(id))
			alive = 1
		else
			alive = 0
		
		if(get_user_team(id) == 1)
			team = 1
		else if(get_user_team(id) == 2)
			team = 2
		else
			team = 0
	
		formatex(zapr, 1023,"SET NAMES `utf8`;INSERT INTO `webchat` (`id`, `name`, `ip`, `steam`, `text`, `hostip`, `time`, `team`, `alive`, `teamchat`) VALUES (NULL, '%s', '%s', '%s', '%s', '%s', '%d', '%d', '%d', '%d')", _name, ip, steam, msg, hostip, get_systime(), team, alive, teamchat)
		SQL_ThreadQuery(g_h_Sql, "say_sql", zapr)
	}
	
#if !defined COLORED_TRANSLIT
	if(rusfix||allchat||adminlisten)
	{
		new name[33], prefix[50]
		get_user_name(id, name, 32)
		if(!is_user_alive(id))
		{
			if(get_user_team(id) == 1||get_user_team(id) == 2)
				formatex(prefix, 49, "*DEAD* ")
			else
				formatex(prefix, 49, "*SPEC* ")
		}
		if(teamchat)
		{
			if(get_user_team(id) == 1)
				formatex(prefix, 49, "%s(Terrorist) ", prefix)
			else	if(get_user_team(id) == 2)
				formatex(prefix, 49, "%s(Counter-Terrorist) ", prefix)
			else
				formatex(prefix, 49, "(Spectator) ")
		}
		replace(prefix, 49, "* (", "*(")
		
		new russmes[200]
		formatex(russmes, 199, "^x01%s^x03%s^x01 :  %s", prefix, name, message)
		
		for(new i=1;i<=maxplayers;i++)
		{
			if(!is_user_connected(i)) continue
			if(is_user_alive(i)==is_user_alive(id)||(adminlisten&&get_user_flags(i)&ADMIN_CHAT)||allchat)
			{
				if((teamchat&&get_user_team(i)==get_user_team(id))||!teamchat||(adminlisten&&get_user_flags(i)&ADMIN_CHAT))
				{
					client_print(i, print_notify, "%s%s :  %s", prefix, name, message)
					message_begin( MSG_ONE, get_user_msgid( "SayText" ), _, i)
					write_byte(id)
					write_string(russmes)
					message_end()
				}
			}
		}
		
		return PLUGIN_HANDLED_MAIN
	}
#endif
	
	return PLUGIN_CONTINUE
}
public say_sql(iFailState, Handle:hQuery, error[], err)
{
	if(iFailState != TQUERY_SUCCESS)
    	{
        	log_amx("sql error: %d (%s)", err, error)
        	if(iFailState == TQUERY_CONNECT_FAILED)
        	{
        		if(rcmysql)
        		{
        			is_connected_mysql=false
        			set_task(reconnecttime,"reconnect_to_mysql",68046,_,_,"b")
        			log_amx("Reconnect to database...")
        		}
        		else set_fail_state("stoped")
        	}
        	return
    	}
}

public plugin_cfg()
{
	new iCfgDir[ 32 ], iFile[ 192 ]
	
	get_configsdir( iCfgDir, charsmax( iCfgDir ) )
	formatex( iFile, charsmax( iFile ), "%s/webchat.cfg", iCfgDir )

	if( !file_exists( iFile ) )
	{
		log_amx( "Ошибка чтения файла webchat.cfg" )
		set_fail_state("stoped")
	}
	else
		server_cmd( "exec %s", iFile )
}

public reconnect_to_mysql()
{
	if(g_h_Sql_Connect != Empty_Handle) SQL_FreeHandle(g_h_Sql_Connect)
    	SQL_FreeHandle(g_h_Sql)
    	new s_Error[128], i_Error
	g_h_Sql = SQL_MakeDbTuple(host, user, pass, db)
	g_h_Sql_Connect = SQL_Connect(g_h_Sql, i_Error, s_Error, charsmax(s_Error))
	
	if(g_h_Sql_Connect == Empty_Handle)
	{
		log_amx("Can't connect to MySQL, error: %s^nReconnect to database...", s_Error)
	}
	else
	{
		remove_task(68046)
		log_amx("Connected")
		is_connected_mysql = true
		new _hostname[256], hostip[32], _hostip1[64], _hostname1[512]
   		get_pcvar_string(g_pCvar_ipfix, _hostip, 31)
		get_cvar_string("hostname", _hostname, 255)
		if(equali(_hostip, ""))
			get_user_ip(0, hostip, 31)
		else
			formatex(hostip, 31, "%s", _hostip)
			
		SQL_QuoteString(g_h_Sql_Connect, _hostname1, 511, _hostname)
		SQL_QuoteString(g_h_Sql_Connect, _hostip1, 63, hostip)	
		SQL_QueryAndIgnore(g_h_Sql_Connect, "SET NAMES `utf8`")
		SQL_QueryAndIgnore(g_h_Sql_Connect, "CREATE TABLE IF NOT EXISTS `webchat` ( `id` int(8) NOT NULL AUTO_INCREMENT, `name` varchar(32) NOT NULL, `ip` varchar(32) NOT NULL, `steam` varchar(32) NOT NULL, `text` varchar(400) NOT NULL, `hostip` varchar(32) NOT NULL, `time` int(32) NOT NULL, `team` int(8) NOT NULL, `alive` int(8) NOT NULL, `teamchat` int(8) NOT NULL, PRIMARY KEY (`id`) ) ENGINE=MyISAM  DEFAULT CHARSET=utf8;")
		SQL_QueryAndIgnore(g_h_Sql_Connect, "CREATE TABLE IF NOT EXISTS `host` ( `hostname` varchar(255) NOT NULL, `hostip` varchar(255) NOT NULL, PRIMARY KEY (`hostip`) ) ENGINE=MyISAM DEFAULT CHARSET=utf8;")
		SQL_QueryAndIgnore(g_h_Sql_Connect, "INSERT INTO `host` SET hostname='%s', hostip='%s' ON DUPLICATE KEY UPDATE hostname='%s'", _hostname1, _hostip1, _hostname1)
	}
}

public connect_data_base()
{
	new s_Error[128], i_Error
	
	get_pcvar_string(g_pCvarSQLHost, host, 63)
	get_pcvar_string(g_pCvarSQLUser, user, 63)
	get_pcvar_string(g_pCvarSQLPass, pass, 127)
	get_pcvar_string(g_pCvarSQLDb, db, 127)
	ignore = get_pcvar_num(g_pCvar_sim)
#if !defined COLORED_TRANSLIT
	rusfix = get_pcvar_num(g_pCvar_rusfix)
	allchat = get_pcvar_num(g_pCvar_allchat)
	adminlisten = get_pcvar_num(g_pCvar_adminlisten)
#endif
	reconnecttime = get_pcvar_float(g_pCvar_reconnecttime)
	if(reconnecttime<5.0) reconnecttime = 5.0
	else if(reconnecttime>60.0) reconnecttime = 60.0
	rcmysql = get_pcvar_num(g_pCvar_reconnectmysql)
	
	g_h_Sql = SQL_MakeDbTuple(host, user, pass, db)
	g_h_Sql_Connect = SQL_Connect(g_h_Sql, i_Error, s_Error, charsmax(s_Error))
	
	if(g_h_Sql_Connect == Empty_Handle)
	{
		if(rcmysql)
		{
			log_amx("Can't connect to MySQL, error: %s^nReconnect to database...", s_Error)
			set_task(reconnecttime,"reconnect_to_mysql",68046,_,_,"b")
		}
		else
		{
			log_amx("Can't connect to MySQL, error: %s", s_Error)
			set_fail_state("stoped")
		}
	}
	else
	{
		is_connected_mysql = true
		new _hostname[256], hostip[32], _hostip1[64], _hostname1[512]
   		get_pcvar_string(g_pCvar_ipfix, _hostip, 31)
		get_cvar_string("hostname", _hostname, 255)
		if(equali(_hostip, ""))
			get_user_ip(0, hostip, 31)
		else
			formatex(hostip, 31, "%s", _hostip)
			
		SQL_QuoteString(g_h_Sql_Connect, _hostname1, 511, _hostname)
		SQL_QuoteString(g_h_Sql_Connect, _hostip1, 65, hostip)	
		SQL_QueryAndIgnore(g_h_Sql_Connect, "SET NAMES `utf8`")
		SQL_QueryAndIgnore(g_h_Sql_Connect, "CREATE TABLE IF NOT EXISTS `webchat` ( `id` int(8) NOT NULL AUTO_INCREMENT, `name` varchar(32) NOT NULL, `ip` varchar(32) NOT NULL, `steam` varchar(32) NOT NULL, `text` varchar(400) NOT NULL, `hostip` varchar(32) NOT NULL, `time` int(32) NOT NULL, `team` int(8) NOT NULL, `alive` int(8) NOT NULL, `teamchat` int(8) NOT NULL, PRIMARY KEY (`id`) ) ENGINE=MyISAM  DEFAULT CHARSET=utf8;")
		SQL_QueryAndIgnore(g_h_Sql_Connect, "CREATE TABLE IF NOT EXISTS `host` ( `hostname` varchar(255) NOT NULL, `hostip` varchar(255) NOT NULL, PRIMARY KEY (`hostip`) ) ENGINE=MyISAM DEFAULT CHARSET=utf8;")
		SQL_QueryAndIgnore(g_h_Sql_Connect, "INSERT INTO `host` SET hostname='%s', hostip='%s' ON DUPLICATE KEY UPDATE hostname='%s'", _hostname1, _hostip1, _hostname1)
	}
}

public plugin_end()
{
    	if(g_h_Sql_Connect != Empty_Handle) SQL_FreeHandle(g_h_Sql_Connect)
    	SQL_FreeHandle(g_h_Sql)
}